/*
 * TimeStampSample.java
 */

import java.io.*;
import java.util.*;
import java.net.*;
import java.security.*;
import java.nio.file.*;

public class TimeStampSample {

    // ---------------------------------------------------------------------------
    // C֐.
	public static void main(String[] args) {

		// ^Cg\ƈmF
		System.out.println("Java TimeStamp Test");
		if(args.length < 3)
		{
			System.out.println("usage:");
			System.out.println("> java TimeStampSample <target file> <server url> <output file>");
			return;
		}
		String targetFile  = args[0];
		System.out.println("target file : " + targetFile);
		String serverUrl  = args[1];
		System.out.println("server url  : " + serverUrl);
		String outputFile = args[2];
		System.out.println("output file : " + outputFile);

    	try
    	{
			// ^CX^v擾
			boolean rc = TimeStampTest(targetFile, serverUrl, outputFile);
			if(!rc)
			{
				System.out.println("TimeStamp Error.");
				return;
			}
			System.out.println("TimeStamp Get OK.");

    	}
    	catch(Exception e)
    	{
       	    System.out.println(e);
	    	System.out.println("ERROR BY EXCEPTION!!!!!");
	    	return;
    	}

		System.out.println("Done.");
	}

    // ---------------------------------------------------------------------------
    // Ot@CDetached̎iPKCS#12t@Cgpj.
    private static boolean TimeStampTest(String target, String url, String outfile) throws Exception
    {
		// Ώۃt@C̓ǂݍ
		Path path = Paths.get(target);
		byte[] bytes = Files.readAllBytes(path);

		// Ώۃt@C̃nbVlvZ
    	MessageDigest md = MessageDigest.getInstance("SHA-512");
		md.update(bytes);
		byte[] hash = md.digest();

		// nonce̐
		byte[] nonce = new byte[8];
		new Random().nextBytes(nonce);

		// ^CX^vNGXg̐
		byte[] req = makeRequest(hash, nonce);

		// ^CX^vT[oڑ
		byte[] resp = httpConnect(url, req);

		// ^CX^vX|X̉́i^CX^vg[N擾j
		byte[] tst = parseResponse(resp, nonce);

		// ^CX^vg[N̏o
		Path outpath = Paths.get(outfile);
		Files.write(outpath, tst);

		// I
    	return true;
    }

	/**
	 * ^CX^ṽNGXg̐.
	 * <p>
	 * RFC3161/SHA-512̃NGXgioCi`j𐶐ĕԂB
	 * 
	 * @param hash ^CX^v擾vnbVliSHA-512=64oCgj
	 * @param nonce iXiljwi8oCgj
	 * @return NGXgioCi`jԂ
	 */
	private static byte[] makeRequest (
			byte[] hash,			// 64 oCg
			byte[] nonce			// 8 oCg
			)
	{
		byte[] req = null;

		// SHA-1 NGXg`
		byte[] sha1req = {
				0x30, 0x31,							// Request SEQUENCE (49oCg)
				0x02, 0x01, 0x01,					// Version INTEGER (1oCg) value: 1
				0x30, 0x1f,							// MessageImprint SEQUENCE (31oCg)
				0x30, 0x07,							// AlgorithmOID SEQUENCE (7oCg)
				0x06, 0x05,							// OID (5oCg)
				0x2b, 0x0e, 0x03, 0x02, 0x1a,		// OIDSHA1 value: 1.3.14.3.2.26
				0x04, 0x14,							// Hash OCTET STRING (20oCg)
				0x00, 0x00, 0x00, 0x00, 0x00,		// Placeholders for Hash (+18oCg)
				0x00, 0x00, 0x00, 0x00, 0x00,		// 10
				0x00, 0x00, 0x00, 0x00, 0x00,		// 15
				0x00, 0x00, 0x00, 0x00, 0x00,		// 20
				0x02, 0x08,							// Nonce INTEGER (8oCg)
				0x00, 0x00,	0x00, 0x00, 0x00,		// Placeholders for Nonce (+40oCg)
				0x00, 0x00, 0x00,					// 8
				0x01, 0x01,	(byte)0xff				// RequestCertificate BOOLEAN (1oCg) value: true
		};

		// SHA-512 NGXg`
		byte[] sha512req = {
				0x30, 0x61,							// Request SEQUENCE (97oCg)
				0x02, 0x01, 0x01,					// Version INTEGER (1oCg) value: 1
				0x30, 0x4f,							// MessageImprint SEQUENCE (79oCg)
				0x30, 0x0b,							// AlgorithmOID SEQUENCE (11oCg)
				0x06, 0x09,							// OID (9oCg)
				0x60, (byte)0x86, 0x48, 0x01, 0x65,	// OIDSHA512 value: 2.16.840.1.101.3.4.2.3
				0x03, 0x04, 0x02, 0x03,
				0x04, 0x40,							// Hash OCTET STRING (64oCg)
				0x00, 0x00, 0x00, 0x00, 0x00,		// Placeholders for Hash (+22oCg)
				0x00, 0x00, 0x00, 0x00, 0x00,		// 10
				0x00, 0x00, 0x00, 0x00, 0x00,		// 15
				0x00, 0x00, 0x00, 0x00, 0x00,		// 20
				0x00, 0x00, 0x00, 0x00, 0x00,		// 25
				0x00, 0x00, 0x00, 0x00, 0x00,		// 30
				0x00, 0x00, 0x00, 0x00, 0x00,		// 35
				0x00, 0x00, 0x00, 0x00, 0x00,		// 40
				0x00, 0x00, 0x00, 0x00, 0x00,		// 45
				0x00, 0x00, 0x00, 0x00, 0x00,		// 50
				0x00, 0x00, 0x00, 0x00, 0x00,		// 55
				0x00, 0x00, 0x00, 0x00, 0x00,		// 60
				0x00, 0x00, 0x00, 0x00,				// 64
				0x02, 0x08,							// Nonce INTEGER (8oCg)
				0x00, 0x00,	0x00, 0x00, 0x00,		// Placeholders for Nonce (+88oCg)
				0x00, 0x00, 0x00,					// 8
				0x01, 0x01,	(byte)0xff				// RequestCertificate BOOLEAN (1oCg) value: true
		};

		try {
			if( hash.length == 64 ) {
				// SHA-512
				req = sha512req;
	            System.arraycopy( hash, 0, req, 22, hash.length );			// nbVl̃Zbg
	            if( nonce.length == 8 )
	            	System.arraycopy( nonce, 0, req, 88, nonce.length );	// l̃Zbg
			} else if( hash.length == 20 ) {
				// SHA-1
				req = sha1req;
	            System.arraycopy( hash, 0, req, 18, hash.length );			// nbVl̃Zbg
	            if( nonce.length == 8 )
	            	System.arraycopy( nonce, 0, req, 40, nonce.length );	// l̃Zbg
			} else {
				// ERROR
				return req;
			}
		} catch (Exception e) {
       	    System.out.println(e);
	    	System.out.println("vG[");
		}
		return req;
	}

	/**
	 * ^CX^ṽX|X̉.
	 * <p>
	 * RFC3161̃X|XioCi`j͂ă^CX^vg[NԂB
	 * 
	 * @param res ^CX^vT[oԂꂽX|XioCi`j
	 * @param nonce iXiljwi8oCgj
	 * @return OKȂ擾^CX^vg[NioCi`jԂ
	 */
	private static byte[] parseResponse (
			byte[] res,
			byte[] nonce			// 8 oCg
			)
	{
		byte[] tst = null;
		if( res == null )
			return null;
		int res_len = res.length;

		try {
			int len = -1;
			if( res_len < 2 )
				throw new Exception("res too short");

			int idx = 0;
			if( res[idx++] != ( DERTag.SEQUENCE | DERTag.CONSTRUCTED ) )
				throw new Exception("format error 1");	// ŏSEQUENCEł͖iTSTł͖j
			if( idx > res_len )
				throw new Exception("format error 2");

			if( ( res[idx] & DERTag.LEN_EXTEND ) == 0 ) {
				// PoCg
				len = res[idx++];
			} else {
				// ͊gĂ
				int sz = res[idx++] & DERTag.LEN_MASK;
				if( idx > res_len )
					throw new Exception("format error 3");
				if( sz > 4 || sz <= 0 )
					throw new Exception("format error 4");
				int sz2 = 0;
				for( int i=sz-1; i>=0; i-- ) {
					sz2 |= (res[idx++] & 0xff) << ( 8 * i );
					if( idx > res_len )
						throw new Exception("format error 5");
				}
				if( sz2 <= 0 || sz2 > res_len - idx )
					throw new Exception("format error 6");
				len = sz2;
			}
			if( idx > res_len )
				throw new Exception("format error 7");

			// Status̎擾
			int status = 0;
			if( res[idx++] != ( DERTag.SEQUENCE | DERTag.CONSTRUCTED ) )
				throw new Exception("format error 8");	// SEQUENCEł͖
			if( idx > res_len )
				throw new Exception("format error 9");
			if( ( res[idx++] & DERTag.LEN_EXTEND ) != 0 )
				throw new Exception("format error 10");	// g͂Ƃ肠ΉȂ
			if( idx > res_len )
				throw new Exception("format error 11");
			if( res[idx++] != DERTag.INTEGER )
				throw new Exception("format error 12");	// StatusINTEGER
			if( idx > res_len )
				throw new Exception("format error 13");
			int isz = res[idx++];						// TCY
			if( idx > res_len )
				throw new Exception("format error 14");
			for( int j=isz-1; j>=0; j-- ) {
				status |= (res[idx++] & 0xff) << ( 8 * j );
				if( idx > res_len )
					throw new Exception("format error 15");
			}
			if( status != PKIStatus.GRANTED && status != PKIStatus.GRANT_W_MODS )
				throw new Exception("invalid server res status");	// T[oG[Ԃ

			// c肪TST̂͂
			len = (int)(res_len - idx);
			if( len > res_len )
				throw new Exception("format error 16");
			tst = new byte[len];
            System.arraycopy( res, idx, tst, 0, len );	// TST̃Rs[

		} catch (Exception e) {
       	    System.out.println(e);
	    	System.out.println("ʉ̓G[");
		}
		return tst;
	}

    // ---------------------------------------------------------------------------
    // HTTPʐM.
	private static byte[] httpConnect (
			String url,
			byte[] send
			)
	{
		byte[] back = null;

		try
		{

			URL server = new URL(url);
			HttpURLConnection connection = null;

			try
			{
				// ʐM
				connection = (HttpURLConnection) server.openConnection();
				connection.setRequestMethod("POST");
				connection.setDoOutput(true);
				connection.setRequestProperty("Content-Type", "application/timestamp-query");
				connection.setUseCaches(false);

				// ^CX^vNGXg̏
				OutputStream os = new BufferedOutputStream(connection.getOutputStream());
				os.write(send);
         		os.flush();

				if (connection.getResponseCode() == HttpURLConnection.HTTP_OK)
				{
					BufferedInputStream bis = new BufferedInputStream(connection.getInputStream());
					int nBufSize = 1024 * 100;		// Ƃ肠^CX^v100KBƂ
					byte[] buf = new byte[nBufSize];
					int len = bis.read(buf);
					bis.close();
					if(len <= 0)
					{
	    				System.out.println("HTTPG[");
					}
					else
					{
						// ̂Ń^CX^vX|XԂĂ͂
						back = Arrays.copyOf(buf, len);
					}
				}
			}
			finally
			{
				if (connection != null)
				{
				    connection.disconnect();
				}
			}
		} catch (Exception e) {
       	    System.out.println(e);
	    	System.out.println("HTTPڑG[");
		}
		return back;
	}

    // ---------------------------------------------------------------------------
    // ^CX^vX|X̃Xe[^X.
	public interface PKIStatus {
	    public static final int	GRANTED			= 0;	// TST܂
	    public static final int	GRANT_W_MODS	= 1;	// TST܂݁AvCx[gg܂
	    public static final int	REJECTION		= 2;	// TST܂܂Aۂꂽ
	    public static final int	WAITING			= 3;	// TST܂܂AV[ĝ݊܂
	    public static final int	REVOCAT_WARN	= 4;	// TST܂܂ATSUؖ̎߂
	    public static final int	REVOCAT_NOTF	= 5;	// TST܂܂ATSUؖĂ
	}

    // ---------------------------------------------------------------------------
    // ASN.1/BER(DER)^O`.
	public interface DERTag {
		// ^O
	    public static final byte BOOLEAN             = 0x01;
	    public static final byte INTEGER             = 0x02;
	    public static final byte BIT_STRING          = 0x03;
	    public static final byte OCTET_STRING        = 0x04;
	    public static final byte NULL                = 0x05;
	    public static final byte OBJECT_IDENTIFIER   = 0x06;
	    public static final byte EXTERNAL            = 0x08;
	    public static final byte ENUMERATED          = 0x0a;
	    public static final byte SEQUENCE            = 0x10;
	    public static final byte SET                 = 0x11;
	    public static final byte NUMERIC_STRING      = 0x12;
	    public static final byte PRINTABLE_STRING    = 0x13;
	    public static final byte T61_STRING          = 0x14;
	    public static final byte VIDEOTEX_STRING     = 0x15;
	    public static final byte IA5_STRING          = 0x16;
	    public static final byte UTC_TIME            = 0x17;
	    public static final byte GENERALIZED_TIME    = 0x18;
	    public static final byte GRAPHIC_STRING      = 0x19;
	    public static final byte VISIBLE_STRING      = 0x1a;
	    public static final byte GENERAL_STRING      = 0x1b;
	    public static final byte UNIVERSAL_STRING    = 0x1c;
	    public static final byte BMP_STRING          = 0x1e;
	    public static final byte UTF8_STRING         = 0x0c;
	    // NXE\tO
	    public static final byte CONSTRUCTED         = 0x20;
	    public static final byte APPLICATION         = 0x40;
	    public static final byte CONTEXT_SPECIFIC    = (byte)0x80;
	    public static final byte PRIVATE             = (byte)0xc0;
	    // }XN
	    public static final byte TAGNUM_MASK         = 0x1f;
	    public static final byte TAGCONSTFLAG_MASK   = 0x20;
	    public static final byte TAGCLASS_MASK       = (byte)0xC0;
	    // l
	    public static final byte LEN_MASK            = 0x1f;
	    public static final byte LEN_EXTEND          = (byte)0x80;
	}
}
